#!/usr/bin/perl
#
@set = (
  "1_Test_Led/led_test.v",
  "2_Test_Key/key_test.v",
  "3_Test_PLL/pll_test.v",
  "3_Test_PLL/simulation/modelsim/pll_test.vt",
  "6_7SEG_LED/rtl/demo_control_module.v",
  "6_7SEG_LED/rtl/smg_control_module.v",
  "6_7SEG_LED/rtl/smg_encode_module.v",
  "6_7SEG_LED/rtl/smg_interface.v",
  "6_7SEG_LED/rtl/smg_interface_demo.v",
  "6_7SEG_LED/rtl/smg_scan_module.v",
  "8_VGA/rtl/vga_test.v",
  "9_Test_Ethernet/rtl/crc.v",
  "9_Test_Ethernet/rtl/ethernet.v",
  "9_Test_Ethernet/rtl/ethernet_test.v",
  "9_Test_Ethernet/rtl/iprecieve.v",
  "9_Test_Ethernet/rtl/ipsend.v",
  "9_Test_Ethernet/rtl/udp.v"
);

open( OFILE, ">trans.txt" )      || die "create - $!\n";
open( TFILE, "translate_f.txt" ) || die "open translate_f.txt - $!\n";
foreach $file ( @set )
{
  open( IFILE, "$file" )      || die "open $file - $!\n";
  open( NFILE, ">$file.new" ) || die "create - $!\n";
  while ( $ln = <IFILE> )
  {
    if ( $ln =~ /^([\t -~]*)([^\r\n]*)[\r\n]*$/ )
    {
      if ( $2 ne "" )
      {
        print( OFILE "$2\n" );
        $rep = <TFILE>;
        print( NFILE "$1$rep" );
      }
      else
      {
        print( NFILE "$ln" );
      }
    }
  }
  close( NFILE );
  close( IFILE ) || die "close $file $!\n";
  ( $dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime ) =
      stat( $file );
  unlink "$file";
  rename "$file.new", "$file" || die "move $file.new to $file\n";
  utime $atime, $mtime, "$file";
}
close( TFILE );
close( OFILE );
exit;

# end
